"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useWebSocketContext = exports.WebSocketProvider = void 0;

var _react = _interopRequireWildcard(require("react"));

var _WebSocket = require("../../services/WebSocket");

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var WebSocketContext = (0, _react.createContext)({});

var WebSocketProvider = function WebSocketProvider(_ref) {
  var options = _ref.options,
      children = _ref.children;

  var _useState = (0, _react.useState)({}),
      _useState2 = _slicedToArray(_useState, 2),
      connected = _useState2[0],
      setConnected = _useState2[1];

  var optionsEntries = (0, _react.useMemo)(function () {
    return Object.entries(options);
  }, [options]);
  var handleOpen = (0, _react.useCallback)(function (name) {
    setConnected(function (prev) {
      return _objectSpread(_objectSpread({}, prev), {}, _defineProperty({}, name, true));
    });
  }, []);
  var handleClose = (0, _react.useCallback)(function (name) {
    setConnected(function (prev) {
      return _objectSpread(_objectSpread({}, prev), {}, _defineProperty({}, name, false));
    });
  }, []);
  var webSockets = (0, _react.useMemo)(function () {
    // eslint-disable-next-line unicorn/no-reduce
    return optionsEntries.reduce(function (acc, _ref2) {
      var _ref3 = _slicedToArray(_ref2, 2),
          name = _ref3[0],
          wsOptions = _ref3[1];

      var onOpen = function onOpen() {
        return handleOpen(name);
      };

      var onClose = function onClose() {
        return handleClose(name);
      };

      return _objectSpread(_objectSpread({}, acc), {}, _defineProperty({}, name, new _WebSocket.WebSocketService(_objectSpread({
        name: name
      }, wsOptions), onOpen, onClose)));
    }, {});
  }, [!optionsEntries.length]);
  (0, _react.useEffect)(function () {
    if (optionsEntries.length !== Object.values(webSockets).length) return;
    optionsEntries.map(function (_ref4) {
      var _ref5 = _slicedToArray(_ref4, 2),
          name = _ref5[0],
          wsOptions = _ref5[1];

      // This "false" check is required here since the value can be "undefined".
      // The socket needs to be connected when "undefined".
      if (wsOptions.autoConnect === false) return;
      webSockets[name].open();
    });
  }, [Object.values(webSockets).length]);
  return <WebSocketContext.Provider value={{
    connected: connected,
    webSockets: webSockets,
    options: options
  }}>
      {children}
    </WebSocketContext.Provider>;
};

exports.WebSocketProvider = WebSocketProvider;

var useWebSocketContext = function useWebSocketContext(name) {
  var context = (0, _react.useContext)(WebSocketContext);
  if (!context) throw new Error('WebSocket context not found. Make sure you use hooks inside a <WebSocketProvider>');
  var multiply = Object.keys(context.options).length > 1;
  if (multiply && !name) throw new Error('The "name" is required for the hook usage');
  var webSocketName = multiply ? name : Object.keys(context.options)[0];
  var webSockets = context.webSockets,
      options = context.options,
      connected = context.connected;
  return _objectSpread(_objectSpread({}, webSockets[webSocketName]), {}, {
    connected: connected[webSocketName],
    getRequestIndicator: options[webSocketName].getRequestIndicator
  });
};

exports.useWebSocketContext = useWebSocketContext;