"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.useSubscription = exports.useLazySubscription = void 0;

var _react = require("react");

var _WebSocket = require("../../contexts/WebSocket");

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

var initialState = {
  data: null,
  error: null
};

var useSubscription = function useSubscription(signal, options) {
  var _useWebSocketContext = (0, _WebSocket.useWebSocketContext)(options === null || options === void 0 ? void 0 : options.name),
      addSignalListener = _useWebSocketContext.addSignalListener;

  var removeListener = (0, _react.useRef)(null);

  var _useState = (0, _react.useState)(initialState),
      _useState2 = _slicedToArray(_useState, 2),
      state = _useState2[0],
      setState = _useState2[1];

  (0, _react.useEffect)(function () {
    removeListener.current = addSignalListener(signal, function (error, response) {
      setState({
        error: error,
        data: response
      });
    });
    return removeListener.current;
  }, []);
  var stop = (0, _react.useCallback)(function () {
    var _removeListener$curre;

    (_removeListener$curre = removeListener.current) === null || _removeListener$curre === void 0 ? void 0 : _removeListener$curre.call(removeListener);
  }, []);
  return [state, {
    stop: stop
  }];
};

exports.useSubscription = useSubscription;

var useLazySubscription = function useLazySubscription(signal, options) {
  var _useWebSocketContext2 = (0, _WebSocket.useWebSocketContext)(options === null || options === void 0 ? void 0 : options.name),
      addSignalListener = _useWebSocketContext2.addSignalListener;

  var removeListener = (0, _react.useRef)(null);

  var _useState3 = (0, _react.useState)(initialState),
      _useState4 = _slicedToArray(_useState3, 2),
      state = _useState4[0],
      setState = _useState4[1];

  (0, _react.useEffect)(function () {
    return function () {
      var _removeListener$curre2;

      (_removeListener$curre2 = removeListener.current) === null || _removeListener$curre2 === void 0 ? void 0 : _removeListener$curre2.call(removeListener);
    };
  }, []);
  var start = (0, _react.useCallback)(function () {
    removeListener.current = addSignalListener(signal, function (error, response) {
      setState({
        error: error,
        data: response
      });
    });
  }, []);
  var stop = (0, _react.useCallback)(function () {
    var _removeListener$curre3;

    (_removeListener$curre3 = removeListener.current) === null || _removeListener$curre3 === void 0 ? void 0 : _removeListener$curre3.call(removeListener);
  }, []);
  return [state, {
    start: start,
    stop: stop
  }];
};

exports.useLazySubscription = useLazySubscription;