"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ReconnectorService = void 0;

var _Logger = require("../Logger");

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var _interval = /*#__PURE__*/new WeakMap();

var _callback = /*#__PURE__*/new WeakMap();

var _loggerService = /*#__PURE__*/new WeakMap();

var _reconnections = /*#__PURE__*/new WeakMap();

var _timeout = /*#__PURE__*/new WeakMap();

var _getInterval = /*#__PURE__*/new WeakMap();

var _setReconnections = /*#__PURE__*/new WeakMap();

var _incrementReconnections = /*#__PURE__*/new WeakMap();

var _resetReconnections = /*#__PURE__*/new WeakMap();

var ReconnectorService = /*#__PURE__*/_createClass(function ReconnectorService(callback) {
  var _this = this;

  var _interval2 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 1000;

  var _ref = arguments.length > 2 ? arguments[2] : undefined,
      debug = _ref.debug,
      prefix = _ref.prefix;

  _classCallCheck(this, ReconnectorService);

  _classPrivateFieldInitSpec(this, _interval, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _callback, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _loggerService, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _reconnections, {
    writable: true,
    value: 0
  });

  _classPrivateFieldInitSpec(this, _timeout, {
    writable: true,
    value: null
  });

  _defineProperty(this, "startJob", function () {
    var _classPrivateFieldGet2;

    var interval = _classPrivateFieldGet(_this, _getInterval).call(_this);

    (_classPrivateFieldGet2 = _classPrivateFieldGet(_this, _loggerService)) === null || _classPrivateFieldGet2 === void 0 ? void 0 : _classPrivateFieldGet2.log("Reconnect in ".concat(interval, "ms"));

    _classPrivateFieldSet(_this, _timeout, setTimeout(_classPrivateFieldGet(_this, _callback), interval));

    _classPrivateFieldGet(_this, _incrementReconnections).call(_this);
  });

  _defineProperty(this, "removeJob", function () {
    clearTimeout(_classPrivateFieldGet(_this, _timeout));

    _classPrivateFieldSet(_this, _timeout, null);

    _classPrivateFieldGet(_this, _resetReconnections).call(_this);
  });

  _classPrivateFieldInitSpec(this, _getInterval, {
    writable: true,
    value: function value() {
      var interval = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _classPrivateFieldGet(_this, _interval);
      if (typeof interval === 'number') return interval;
      if (!interval.length) return 0;
      var lastIntervalsIdx = interval.length - 1;

      if (_classPrivateFieldGet(_this, _reconnections) <= lastIntervalsIdx) {
        return interval[_classPrivateFieldGet(_this, _reconnections)];
      }

      return interval[lastIntervalsIdx];
    }
  });

  _classPrivateFieldInitSpec(this, _setReconnections, {
    writable: true,
    value: function value(_value) {
      _classPrivateFieldSet(_this, _reconnections, _value);
    }
  });

  _classPrivateFieldInitSpec(this, _incrementReconnections, {
    writable: true,
    value: function value() {
      var start = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _classPrivateFieldGet(_this, _reconnections);

      _classPrivateFieldGet(_this, _setReconnections).call(_this, start + 1);
    }
  });

  _classPrivateFieldInitSpec(this, _resetReconnections, {
    writable: true,
    value: function value() {
      _classPrivateFieldGet(_this, _setReconnections).call(_this, 0);
    }
  });

  _classPrivateFieldSet(this, _interval, _interval2);

  _classPrivateFieldSet(this, _callback, callback);

  if (debug) {
    _classPrivateFieldSet(this, _loggerService, new _Logger.LoggerService(prefix));
  }
});

exports.ReconnectorService = ReconnectorService;