"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SerializerService = void 0;

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var _serializer = /*#__PURE__*/new WeakMap();

var _deserializer = /*#__PURE__*/new WeakMap();

var SerializerService = /*#__PURE__*/_createClass(function SerializerService(serializer, deserializer) {
  var _this = this;

  _classCallCheck(this, SerializerService);

  _classPrivateFieldInitSpec(this, _serializer, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _deserializer, {
    writable: true,
    value: void 0
  });

  _defineProperty(this, "serialize", function (data) {
    var _classPrivateFieldGet2;

    var serializedData = ((_classPrivateFieldGet2 = _classPrivateFieldGet(_this, _serializer)) === null || _classPrivateFieldGet2 === void 0 ? void 0 : _classPrivateFieldGet2.call(_this, data)) || data;
    return SerializerService.serializeJSON(serializedData);
  });

  _defineProperty(this, "deserialize", function (data) {
    var _classPrivateFieldGet3;

    return ((_classPrivateFieldGet3 = _classPrivateFieldGet(_this, _deserializer)) === null || _classPrivateFieldGet3 === void 0 ? void 0 : _classPrivateFieldGet3.call(_this, data)) || data;
  });

  _classPrivateFieldSet(this, _serializer, serializer);

  _classPrivateFieldSet(this, _deserializer, deserializer);
});

exports.SerializerService = SerializerService;

_defineProperty(SerializerService, "deserializeJSON", function (data) {
  try {
    return JSON.parse(data);
  } catch (_unused) {
    return data;
  }
});

_defineProperty(SerializerService, "serializeJSON", function (data) {
  if (typeof data === 'string') return data;
  return JSON.stringify(data);
});