"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SignalListenersService = void 0;

var _Random = require("../Random");

var _Logger = require("../Logger");

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var _loggerService = /*#__PURE__*/new WeakMap();

var _randomService = /*#__PURE__*/new WeakMap();

var _listeners = /*#__PURE__*/new WeakMap();

var _getListeners = /*#__PURE__*/new WeakMap();

var SignalListenersService = /*#__PURE__*/_createClass(function SignalListenersService(_ref) {
  var _this = this;

  var debug = _ref.debug,
      prefix = _ref.prefix;

  _classCallCheck(this, SignalListenersService);

  _classPrivateFieldInitSpec(this, _loggerService, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _randomService, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _listeners, {
    writable: true,
    value: []
  });

  _defineProperty(this, "add", function (indicator, listener) {
    var _classPrivateFieldGet2;

    var id = _classPrivateFieldGet(_this, _randomService).generateString();

    _classPrivateFieldSet(_this, _listeners, [].concat(_toConsumableArray(_classPrivateFieldGet(_this, _listeners)), [{
      id: id,
      indicator: indicator,
      listener: listener
    }]));

    (_classPrivateFieldGet2 = _classPrivateFieldGet(_this, _loggerService)) === null || _classPrivateFieldGet2 === void 0 ? void 0 : _classPrivateFieldGet2.log("Added listener for \"".concat(indicator, "\""), {
      id: id
    });
    return function () {
      return _this.remove(indicator, id);
    };
  });

  _defineProperty(this, "remove", function (indicator, id) {
    var _classPrivateFieldGet3;

    if (!_classPrivateFieldGet(_this, _listeners).length) return;

    _classPrivateFieldSet(_this, _listeners, _classPrivateFieldGet(_this, _listeners).filter(function (listener) {
      return !(listener.indicator === indicator && listener.id === id);
    }));

    (_classPrivateFieldGet3 = _classPrivateFieldGet(_this, _loggerService)) === null || _classPrivateFieldGet3 === void 0 ? void 0 : _classPrivateFieldGet3.log("Removed listener for \"".concat(indicator, "\""), {
      id: id
    });
  });

  _defineProperty(this, "ping", function (indicator, data, error) {
    var _classPrivateFieldGet4;

    var listeners = _classPrivateFieldGet(_this, _getListeners).call(_this, indicator);

    (_classPrivateFieldGet4 = _classPrivateFieldGet(_this, _loggerService)) === null || _classPrivateFieldGet4 === void 0 ? void 0 : _classPrivateFieldGet4.log(!(listeners !== null && listeners !== void 0 && listeners.length) ? 'Ignored (no listeners)' : 'Received', data);

    if (listeners.length) {
      listeners.forEach(function (_ref2) {
        var listener = _ref2.listener;
        listener(error, data);
      });
    }
  });

  _classPrivateFieldInitSpec(this, _getListeners, {
    writable: true,
    value: function value(indicator) {
      return _classPrivateFieldGet(_this, _listeners).filter(function (listener) {
        return listener.indicator === indicator;
      });
    }
  });

  _classPrivateFieldSet(this, _randomService, new _Random.RandomService());

  if (debug) {
    _classPrivateFieldSet(this, _loggerService, new _Logger.LoggerService(prefix));
  }
});

exports.SignalListenersService = SignalListenersService;