"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StorageService = void 0;

var _Serializer = require("../Serializer");

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }

function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var NAME = 'react-use-socket';

var _storage = /*#__PURE__*/new WeakMap();

var _name = /*#__PURE__*/new WeakMap();

var _state = /*#__PURE__*/new WeakMap();

var _comparePayload = /*#__PURE__*/new WeakMap();

var _getState = /*#__PURE__*/new WeakMap();

var _saveState = /*#__PURE__*/new WeakMap();

var StorageService = /*#__PURE__*/_createClass(function StorageService(persist) {
  var _this = this;

  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : NAME;

  _classCallCheck(this, StorageService);

  _classPrivateFieldInitSpec(this, _storage, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _name, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _state, {
    writable: true,
    value: void 0
  });

  _defineProperty(this, "get", function (signal) {
    if (!_classPrivateFieldGet(_this, _state)) return null;
    return _classPrivateFieldGet(_this, _state)[signal];
  });

  _defineProperty(this, "set", function (query, payload, callback) {
    var _classPrivateFieldGet2;

    var comparedPayload = _classPrivateFieldGet(_this, _comparePayload).call(_this, (_classPrivateFieldGet2 = _classPrivateFieldGet(_this, _state)) === null || _classPrivateFieldGet2 === void 0 ? void 0 : _classPrivateFieldGet2[query], payload);

    var newState = _objectSpread(_objectSpread({}, _classPrivateFieldGet(_this, _state)), {}, _defineProperty({}, query, comparedPayload));

    _classPrivateFieldGet(_this, _saveState).call(_this, newState);

    callback === null || callback === void 0 ? void 0 : callback();
  });

  _defineProperty(this, "remove", function (signal, callback) {
    if (!_classPrivateFieldGet(_this, _state)) return;

    var _classPrivateFieldGet3 = _classPrivateFieldGet(_this, _state),
        removedSignal = _classPrivateFieldGet3[signal],
        newState = _objectWithoutProperties(_classPrivateFieldGet3, [signal].map(_toPropertyKey));

    _classPrivateFieldGet(_this, _saveState).call(_this, newState);

    callback === null || callback === void 0 ? void 0 : callback();
  });

  _defineProperty(this, "wipe", function () {
    _classPrivateFieldGet(_this, _storage).removeItem(_classPrivateFieldGet(_this, _name));
  });

  _classPrivateFieldInitSpec(this, _comparePayload, {
    writable: true,
    value: function value() {
      var oldPayload = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var newPayload = arguments.length > 1 ? arguments[1] : undefined;
      if (_typeof(oldPayload) !== 'object' || _typeof(newPayload) !== 'object' || _typeof(oldPayload) !== _typeof(newPayload) || Array.isArray(newPayload)) return newPayload;
      return _objectSpread(_objectSpread({}, oldPayload), newPayload);
    }
  });

  _classPrivateFieldInitSpec(this, _getState, {
    writable: true,
    value: function value() {
      var state = _classPrivateFieldGet(_this, _storage).getItem(_classPrivateFieldGet(_this, _name));

      if (!state) return null;
      return _Serializer.SerializerService.deserializeJSON(state);
    }
  });

  _classPrivateFieldInitSpec(this, _saveState, {
    writable: true,
    value: function value(state) {
      _classPrivateFieldSet(_this, _state, state);

      _classPrivateFieldGet(_this, _storage).setItem(_classPrivateFieldGet(_this, _name), _Serializer.SerializerService.serializeJSON(state));
    }
  });

  _classPrivateFieldSet(this, _storage, persist ? localStorage : sessionStorage);

  _classPrivateFieldSet(this, _name, name);

  _classPrivateFieldSet(this, _state, _classPrivateFieldGet(this, _getState).call(this));
});

exports.StorageService = StorageService;

_defineProperty(StorageService, "isSupported", function (persist) {
  return Boolean(persist ? localStorage : sessionStorage);
});