"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WebSocketService = void 0;

var _typedef = require("./typedef");

var _Logger = require("../Logger");

var _Serializer = require("../Serializer");

var _SignalListeners = require("../SignalListeners");

var _Reconnector = require("../Reconnector");

var _excluded = ["shouldReconnect", "reconnectionInterval", "serialize", "deserialize", "debug", "name"];

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

var _options = /*#__PURE__*/new WeakMap();

var _shouldReconnect = /*#__PURE__*/new WeakMap();

var _openCallback = /*#__PURE__*/new WeakMap();

var _closeCallback = /*#__PURE__*/new WeakMap();

var _loggerService = /*#__PURE__*/new WeakMap();

var _reconnectorService = /*#__PURE__*/new WeakMap();

var _signalListenersService = /*#__PURE__*/new WeakMap();

var _serializerService = /*#__PURE__*/new WeakMap();

var _ws = /*#__PURE__*/new WeakMap();

var _setListeners = /*#__PURE__*/new WeakMap();

var _removeListeners = /*#__PURE__*/new WeakMap();

var _handleOpen = /*#__PURE__*/new WeakMap();

var _handleMessage = /*#__PURE__*/new WeakMap();

var _handleError = /*#__PURE__*/new WeakMap();

var _handleClose = /*#__PURE__*/new WeakMap();

var _checkOpenStateAndThrowError = /*#__PURE__*/new WeakMap();

var WebSocketService = /*#__PURE__*/_createClass(function WebSocketService(options, openCallback, closeCallback) {
  var _this = this;

  _classCallCheck(this, WebSocketService);

  _classPrivateFieldInitSpec(this, _options, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _shouldReconnect, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _openCallback, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _closeCallback, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _loggerService, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _reconnectorService, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _signalListenersService, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _serializerService, {
    writable: true,
    value: void 0
  });

  _classPrivateFieldInitSpec(this, _ws, {
    writable: true,
    value: null
  });

  _defineProperty(this, "open", function () {
    var _classPrivateFieldGet2 = _classPrivateFieldGet(_this, _options),
        url = _classPrivateFieldGet2.url,
        protocols = _classPrivateFieldGet2.protocols;

    if (typeof window === 'undefined' || _classPrivateFieldGet(_this, _ws)) return;

    _classPrivateFieldSet(_this, _ws, new WebSocket(url, protocols));

    _classPrivateFieldGet(_this, _setListeners).call(_this);
  });

  _defineProperty(this, "send", function (data) {
    var _classPrivateFieldGet3;

    _classPrivateFieldGet(_this, _checkOpenStateAndThrowError).call(_this);

    var message = _classPrivateFieldGet(_this, _serializerService).serialize(data);

    _classPrivateFieldGet(_this, _ws).send(message);

    (_classPrivateFieldGet3 = _classPrivateFieldGet(_this, _loggerService)) === null || _classPrivateFieldGet3 === void 0 ? void 0 : _classPrivateFieldGet3.log('Sent', JSON.parse(message));
  });

  _defineProperty(this, "close", function (code) {
    _classPrivateFieldGet(_this, _checkOpenStateAndThrowError).call(_this);

    _classPrivateFieldGet(_this, _ws).close(code);
  });

  _defineProperty(this, "addSignalListener", function (indicator, listener) {
    return _classPrivateFieldGet(_this, _signalListenersService).add(indicator, listener);
  });

  _defineProperty(this, "removeSignalListener", function (indicator, id) {
    _classPrivateFieldGet(_this, _signalListenersService).remove(indicator, id);
  });

  _classPrivateFieldInitSpec(this, _setListeners, {
    writable: true,
    value: function value() {
      if (!_classPrivateFieldGet(_this, _ws)) return;

      _classPrivateFieldGet(_this, _ws).addEventListener(_typedef.WebSocketEvent.OPEN, _classPrivateFieldGet(_this, _handleOpen));

      _classPrivateFieldGet(_this, _ws).addEventListener(_typedef.WebSocketEvent.MESSAGE, _classPrivateFieldGet(_this, _handleMessage));

      _classPrivateFieldGet(_this, _ws).addEventListener(_typedef.WebSocketEvent.ERROR, _classPrivateFieldGet(_this, _handleError));

      _classPrivateFieldGet(_this, _ws).addEventListener(_typedef.WebSocketEvent.CLOSE, _classPrivateFieldGet(_this, _handleClose));
    }
  });

  _classPrivateFieldInitSpec(this, _removeListeners, {
    writable: true,
    value: function value() {
      if (!_classPrivateFieldGet(_this, _ws)) return;

      _classPrivateFieldGet(_this, _ws).removeEventListener(_typedef.WebSocketEvent.OPEN, _classPrivateFieldGet(_this, _handleOpen));

      _classPrivateFieldGet(_this, _ws).removeEventListener(_typedef.WebSocketEvent.MESSAGE, _classPrivateFieldGet(_this, _handleMessage));

      _classPrivateFieldGet(_this, _ws).removeEventListener(_typedef.WebSocketEvent.ERROR, _classPrivateFieldGet(_this, _handleError));

      _classPrivateFieldGet(_this, _ws).removeEventListener(_typedef.WebSocketEvent.CLOSE, _classPrivateFieldGet(_this, _handleClose));
    }
  });

  _classPrivateFieldInitSpec(this, _handleOpen, {
    writable: true,
    value: function value(event) {
      var _classPrivateFieldGet4, _classPrivateFieldGet5;

      (_classPrivateFieldGet4 = _classPrivateFieldGet(_this, _loggerService)) === null || _classPrivateFieldGet4 === void 0 ? void 0 : _classPrivateFieldGet4.log('Connected');
      (_classPrivateFieldGet5 = _classPrivateFieldGet(_this, _openCallback)) === null || _classPrivateFieldGet5 === void 0 ? void 0 : _classPrivateFieldGet5.call(_this, event);

      _classPrivateFieldGet(_this, _reconnectorService).removeJob();
    }
  });

  _classPrivateFieldInitSpec(this, _handleMessage, {
    writable: true,
    value: function value(event) {
      var parsedJson = _Serializer.SerializerService.deserializeJSON(event.data);

      var indicator = _classPrivateFieldGet(_this, _options).getResponseIndicator(parsedJson);

      var data = _classPrivateFieldGet(_this, _serializerService).deserialize(parsedJson);

      var error = _classPrivateFieldGet(_this, _options).getError(parsedJson);

      _classPrivateFieldGet(_this, _signalListenersService).ping(indicator, data, error);
    }
  });

  _classPrivateFieldInitSpec(this, _handleError, {
    writable: true,
    value: function value(event) {
      var _classPrivateFieldGet6;

      (_classPrivateFieldGet6 = _classPrivateFieldGet(_this, _loggerService)) === null || _classPrivateFieldGet6 === void 0 ? void 0 : _classPrivateFieldGet6.error('Error', event);
    }
  });

  _classPrivateFieldInitSpec(this, _handleClose, {
    writable: true,
    value: function value(event) {
      var _classPrivateFieldGet7, _classPrivateFieldGet8;

      var code = event.code,
          reason = event.reason;
      var forceDisconnection = code === _typedef.WebSocketClosingCode.FORCE_CLOSE;
      (_classPrivateFieldGet7 = _classPrivateFieldGet(_this, _loggerService)) === null || _classPrivateFieldGet7 === void 0 ? void 0 : _classPrivateFieldGet7.log('Disconnected', {
        code: code,
        forceDisconnection: forceDisconnection,
        reason: reason
      });
      (_classPrivateFieldGet8 = _classPrivateFieldGet(_this, _closeCallback)) === null || _classPrivateFieldGet8 === void 0 ? void 0 : _classPrivateFieldGet8.call(_this, event);

      _classPrivateFieldGet(_this, _removeListeners).call(_this);

      _classPrivateFieldSet(_this, _ws, null);

      if (forceDisconnection && typeof _classPrivateFieldGet(_this, _shouldReconnect) === 'boolean') return;

      if (typeof _classPrivateFieldGet(_this, _shouldReconnect) === 'boolean') {
        _classPrivateFieldGet(_this, _reconnectorService).startJob();

        return;
      }

      if (_classPrivateFieldGet(_this, _shouldReconnect).call(_this, event)) {
        _classPrivateFieldGet(_this, _reconnectorService).startJob();
      }
    }
  });

  _classPrivateFieldInitSpec(this, _checkOpenStateAndThrowError, {
    writable: true,
    value: function value() {
      var _classPrivateFieldGet9;

      if (((_classPrivateFieldGet9 = _classPrivateFieldGet(_this, _ws)) === null || _classPrivateFieldGet9 === void 0 ? void 0 : _classPrivateFieldGet9.readyState) === WebSocket.OPEN) return;
      throw new Error('WebSocket is not connected. Make sure it is connected before triggering an action.');
    }
  });

  var shouldReconnect = options.shouldReconnect,
      reconnectionInterval = options.reconnectionInterval,
      serialize = options.serialize,
      deserialize = options.deserialize,
      debug = options.debug,
      name = options.name,
      restOptions = _objectWithoutProperties(options, _excluded);

  var debugMeta = {
    debug: debug,
    prefix: "".concat(name, ":").concat(restOptions.url)
  };

  _classPrivateFieldSet(this, _options, restOptions);

  _classPrivateFieldSet(this, _shouldReconnect, shouldReconnect !== null && shouldReconnect !== void 0 ? shouldReconnect : true);

  _classPrivateFieldSet(this, _openCallback, openCallback);

  _classPrivateFieldSet(this, _closeCallback, closeCallback);

  _classPrivateFieldSet(this, _serializerService, new _Serializer.SerializerService(serialize, deserialize));

  _classPrivateFieldSet(this, _signalListenersService, new _SignalListeners.SignalListenersService(debugMeta));

  _classPrivateFieldSet(this, _reconnectorService, new _Reconnector.ReconnectorService(this.open, reconnectionInterval, debugMeta));

  if (debug) {
    _classPrivateFieldSet(this, _loggerService, new _Logger.LoggerService(debugMeta.prefix));

    _classPrivateFieldGet(this, _loggerService).log('Debug mode is ON', _classPrivateFieldGet(this, _options));
  }
}
/*
 * WS Instance State Managers
 */
);

exports.WebSocketService = WebSocketService;