export declare enum WebSocketEvent {
    OPEN = "open",
    MESSAGE = "message",
    ERROR = "error",
    CLOSE = "close"
}
export declare enum WebSocketClosingCode {
    FORCE_CLOSE = 1005
}
export declare type SignalIndicator = string | number;
export declare type ShouldReconnect = (event: CloseEvent) => boolean;
export declare type Options<Req, Res, Err = string, SReq = Req, DRes = Res> = {
    url: string;
    getResponseIndicator: (res: Res) => SignalIndicator;
    getError: (res: Res) => Err | null;
    name?: string;
    protocols?: string | string[];
    shouldReconnect?: ShouldReconnect | boolean;
    reconnectionInterval?: number | number[];
    serialize?: (req: Req) => SReq;
    deserialize?: (res: Res) => DRes;
    debug?: boolean;
};
declare type Short = 'shouldReconnect' | 'reconnectionInterval' | 'deserialize' | 'serialize' | 'debug';
export declare type OptionsShort<Req, Res, Err = string, SReq = Req, DRes = Res> = Omit<Options<Req, Res, Err, SReq, DRes>, Short>;
export declare type OpenCallback = (event: Event) => void;
export declare type CloseCallback = (event: CloseEvent) => void;
export {};
